<?php

class Main extends Controller {

	function Main()
	{
		parent::Controller();

		$this->load->model('main_m');
		$this->load->model('manage_office_m');
		$this->load->model('manage_site_m');
		$this->load->model('manage_country_m');
		$this->load->library('pagination');
		//start session
		session_name(SESS_NAME);
		session_start();
	}

	function index($page_from=0)
	{

		$data['title']="searchanoffice";
		$data['countries']=$this->manage_country_m->get_countrys_list();
		$data['offices']=$this->manage_office_m->get_office_list(0,18,'last_updated','DESC',array('online_status'=>'Online'));
		$this->load->view('main/index',$data);

	}

	function listing($country_id=0,$page_from=0)
	{
		$data['title']="searchanoffice";
		$data['selected_country']=$this->manage_country_m->get_country_info($country_id);
		$data['countries']=$this->manage_country_m->get_countrys_list();
		$config['base_url'] = site_url('main/listing/'.$country_id);
		$config['total_rows'] = $this->manage_office_m->get_office_count(array('online_status'=>'Online','office.country_id'=>$country_id));
		$config['per_page']   = FRONT_LISTING;
		$config['uri_segment'] = 4;
		$this->pagination->initialize($config);
		$data['pagination']= $this->pagination->create_links();
		$data['count']=$config['total_rows'];
		$data['offices']=$this->manage_office_m->get_office_list($page_from,FRONT_LISTING,'office_name','DESC',array('online_status'=>'Online','office.country_id'=>$country_id));
		$this->load->view('main/listing',$data);
	}

	function get_office_list()
	{
		$data['country_common_list']=$this->manage_country_m->get_country_common_list();
		$result="";
		if(sizeof($_SESSION['offices'])>0)
		{
			foreach($_SESSION['offices'] as $office_id=>$office)
			{
				$result.="<div id='requestlist'><a href='".site_url('main/office_detail/'.$office['office_id'])."'>".$office['office_name'].",".$office['countryname']."</a> <div id='right'><a href='javascript:removeOffice(\"".$office['office_id']."\")'>X</a></div></div>";
				$office_ids_arr[]=$office_id;
			}
			$result.="<br /><br />";
			$data['office_ids']=implode(",",$office_ids_arr);
			$result.='<input name="office_ids" type="hidden" id="office_ids" value="'.$data['office_ids'].'" />';
			
		}

		echo $result;
	}
	
	function get_form()
	{
		$data['country_common_list']=$this->manage_country_m->get_country_common_list();
		$this->load->view('main/form',$data);
	}

	function add_office($office_id)
	{
		$office=$this->manage_office_m->get_office_info($office_id);
		$_SESSION['offices'][$office_id]=$office;
	}

	function remove_office($office_id)
	{
		unset($_SESSION['offices'][$office_id]);
	}

	function remove_office_enq($office_id)
	{
		unset($_SESSION['offices'][$office_id]);
		if(sizeof($_SESSION['offices'])>0)
		{
			redirect_ci('main/sendenq');
		}
		else
		{
			redirect_ci('main/index');
		}
	}

	function office_detail($office_id)
	{

		$data['countries']=$this->manage_country_m->get_countrys_list();
		$data['country_common_list']=$this->manage_country_m->get_country_common_list();
		$data['office']=$this->manage_office_m->get_office_info($office_id);
		$data['images']=$this->main_m->get_images($office_id);
		$data['title']="searchanoffice - ".$data['office']['office_name'].",".$data['office']['countryname'];

		if($data['office']==false)
		{
			redirect_ci('main/index');
		}
		$this->load->view('main/office_detail',$data);
	}

	function enquiry_action()
	{
		$offices=$this->input->post('office_ids');
		$title=$this->input->post('salutation');
		$first_name=$this->input->post('first_name');
		$last_name=$this->input->post('last_name');
		$email=$this->input->post('email');
		$contact=$this->input->post('contact');
		$company=$this->input->post('company');
		$start_date=$this->input->post('start_date');
		$office_size=$this->input->post('office_size');
		$question=$this->input->post('question');

		$this->load->library('email');
		$config['protocol'] = 'smtp';
		$config['smtp_host'] = $this->config->item('smtp_host');
		$config['smtp_user'] = $this->config->item('smtp_user');
		$config['smtp_pass'] = $this->config->item('smtp_pass');
		$config['smtp_port'] = 25;
		$config['mailtype'] = "html";
		$office_array=explode(",",$offices);
		$this->email->initialize($config);
		$org_html_content=file_get_contents("./edm/enquiry.html");
		$undefvar =array("{BASEURL}");
		$defvar = array(base_url());
		$org_html_content = str_replace($undefvar, $defvar, $org_html_content);



		foreach($office_array as $office_id)
		{
			$office=$this->manage_office_m->get_office_info($office_id);

			if($office!=false)
			{
				$undefvar =array("{OWNER_NAME}","{TITLE}","{FIRST_NAME}","{LAST_NAME}","{EMAIL}","{OFFICE_SIZE}","{START_DATE}","{COMPANY}","{QUESTION}","{CONTACT}","{ADDRESS}","{VIEW_LINK}");
					$defvar = array($office['owner_name'],$title,$first_name,$last_name,$email,$office_size,$start_date,$company,str_replace("\n","<br />",$question),$contact,$office['address'],site_url('main/office_detail/'.$office_id));
					$html_content = str_replace($undefvar, $defvar, $org_html_content);
					
				if(isValidEmail($office['owner_email']))
				{
					//send to owner
					$this->email->to($office['owner_email']);
					$this->email->from($this->config->item('from_user'));
					$this->email->subject('searchanoffice - Enquiry For '.$office['office_name'].','.$office['countryname']);
					$this->email->message($html_content);
					if ( ! $this->email->send())
					{
						echo "Send mail error!";
						echo $this->email->print_debugger();
						exit();
					}
				}

				//send to admin
				$this->email->to($this->config->item('admin_email'));
				$this->email->from($this->config->item('from_user'));
				$this->email->subject('searchanoffice - Enquiry For '.$office['office_name'].','.$office['countryname']);
				$this->email->message($html_content);
				if ( ! $this->email->send())
				{
					echo "Send mail error!";
					echo $this->email->print_debugger();
					exit();
				}

				$offices_array[]=$office;

				$this->remove_office($office_id);
			}

		}

		//send to requestor
		$this->email->to($email);
		$this->email->from($this->config->item('from_user'));
		$this->email->subject('searchanoffice - Enquiry For Office(s)');
		$message="";
		foreach($offices_array as $office)
		{
			$message.="<tr><td height='20' valign='top'><strong>".$office['office_name'].", ".$office['countryname']."</strong></td><td width='20' height='20' valign='top'>&nbsp;</td><td height='20' valign='top'><a href='".site_url('main/office_detail/'.$office['office_id'])."'><font color='#333333'>View Office Details</font></a></td></tr>";
		}

		$undefvar =array("{BASEURL}","{NAME}","{MESSAGE}");
		$defvar = array(base_url(),$first_name.' '.$last_name,$message);
		$autoreply_html_content=file_get_contents("./edm/autoreply.html");
		$autoreply_html_content = str_replace($undefvar, $defvar, $autoreply_html_content);
		$this->email->message($autoreply_html_content);
		if ( ! $this->email->send())
		{
			echo "Send mail error!";
			echo $this->email->print_debugger();
			exit();
		}

		$data = array(
		'office_ids'    => $offices,
		'title' => $title,
		'first_name' => $first_name,
		'last_name' => $last_name,
		'company' => $company,
		'office_size' => $office_size,
		'start_date' => $start_date,
		'contact' => $contact,
		'comments' => $question,
		'email' => $email,
		'enquiry_datetime' => date("Y-m-d H:i:s")
		);
		$result=$this->main_m->save_enquiry($data);

		redirect_ci('main/enquiry_thank');
	}

	function enquiry_thank()
	{
		$data['title']="searchanoffice - Enquiry Sent";
		$data['countries']=$this->manage_country_m->get_countrys_list();
		$this->load->view('main/enquiry_thank',$data);
	}

	function sendenq()
	{
		$data['title']="searchanoffice - Send Enquiries";
		$data['countries']=$this->manage_country_m->get_countrys_list();
		$data['offices']=$_SESSION['offices'];
		$this->load->view('main/sendenq',$data);
	}

	function about()
	{
		$data['title']="searchanoffice - About Us";
		$data['countries']=$this->manage_country_m->get_countrys_list();
		$data['about']=$this->manage_site_m->get_site_information('about');
		$this->load->view('main/about',$data);
	}
	
	function faq()
	{
		$data['title']="searchanoffice - Frequently Asked Questions";
		$data['countries']=$this->manage_country_m->get_countrys_list();
		$data['faq']=$this->manage_site_m->get_site_information('faq');
		$this->load->view('main/faq',$data);
	}

	function tnc()
	{
		$data['title']="searchanoffice - Terms & Conditions";
		$data['countries']=$this->manage_country_m->get_countrys_list();
		$data['tnc']=$this->manage_site_m->get_site_information('tnc');
		$this->load->view('main/tnc',$data);
	}

	function privacy()
	{
		$data['title']="searchanoffice - Privacy Policy";
		$data['countries']=$this->manage_country_m->get_countrys_list();
		$data['privacy']=$this->manage_site_m->get_site_information('privacy');
		$this->load->view('main/privacy',$data);
	}

	function contact()
	{
		$data['title']="searchanoffice - Contact Us";
		$data['countries']=$this->manage_country_m->get_countrys_list();
		$this->load->view('main/contact',$data);
	}

	function contact_action()
	{
		$name=$this->input->post('name');
		$email=$this->input->post('email');
		$contact=$this->input->post('contact');
		$question=$this->input->post('question');

		$this->load->library('email');
		$config['protocol'] = 'smtp';
		$config['smtp_host'] = $this->config->item('smtp_host');
		$config['smtp_user'] = $this->config->item('smtp_user');
		$config['smtp_pass'] = $this->config->item('smtp_pass');
		$config['smtp_port'] = 25;
		$config['mailtype'] = "html";
		$office_array=explode(",",$offices);
		$this->email->initialize($config);
		$org_html_content=file_get_contents("./edm/contact.html");
		$undefvar =array("{BASEURL}");
		$defvar = array(base_url());
		$org_html_content = str_replace($undefvar, $defvar, $org_html_content);




		//send to admin
		$this->email->to($this->config->item('admin_email'));
		$this->email->from($this->config->item('from_user'));
		$this->email->subject('searchanoffice - Contact Form Submitted');

		$undefvar =array("{NAME}","{EMAIL}","{QUESTION}","{CONTACT}");
		$defvar = array($name,$email,str_replace("\n","<br />",$question),$contact);
		$html_content = str_replace($undefvar, $defvar, $org_html_content);
		$this->email->message($html_content);
		if ( ! $this->email->send())
		{
			echo "Send mail error!";
			echo $this->email->print_debugger();
			exit();
		}

		$data = array(
		'name' => $name,
		'contact' => $contact,
		'comments' => $question,
		'email' => $email,
		'contact_datetime' => date("Y-m-d H:i:s")
		);
		$result=$this->main_m->save_contact($data);

		redirect_ci('main/contact_thank');
	}

	function contact_thank()
	{
		$data['title']="searchanoffice - Contact Form Sent";
		$data['countries']=$this->manage_country_m->get_countrys_list();
		$this->load->view('main/contact_thank',$data);
	}





}
?>