<?php

class Manage_office extends Controller {

	function Manage_office()
	{
		parent::Controller();

		$this->load->model('manage_office_m');
		$this->load->model('manage_country_m');
		$this->load->library('pagination');
		$this->load->library('image_lib');
		//start session
		session_name(SESS_NAME);
		session_start();
		if(!empty($_SESSION['admin_id'])&&$_SESSION['role']=='Admin')
		{
			$this->USER_ID = $_SESSION['admin_id'];
		}
		else
		{
			redirect_ci("admin/login");
		}
		require 'Excel/reader.php';
		require_once 'Excel/Writer.php';
	}

	function index_new()
	{
		$_SESSION['order_by']="";
		$_SESSION['order']="";
		redirect_ci("manage_office/index");
	}

	function index($page_from=0)
	{

		$data['title']="Office Management";

		if($this->input->post('office')==1)
		{
			$_SESSION['order_by']=$this->input->post('sort_name');
			$_SESSION['order']=$this->input->post('order');
		}

		if($this->input->post('search')==1)
		{
			$_SESSION['search']['office_name']=trim($this->input->post('office_name'));
			$_SESSION['search']['countryname']=trim($this->input->post('countryname'));
			$_SESSION['search']['owner_name']=trim($this->input->post('owner_name'));
			$_SESSION['search']['owner_email']=trim($this->input->post('owner_email'));
			$_SESSION['search']['online_status']=trim($this->input->post('online_status'));
		}

		if($_SESSION['search']['online_status']=='')
		{
			$_SESSION['search']['online_status']='Online';
		}

		$config['base_url'] = site_url('manage_office/index');
		$config['total_rows'] = $this->manage_office_m->get_office_count($_SESSION['search']);
		$config['per_page']   = ADMIN_LISTING;
		$config['uri_segment'] = 3;
		$this->pagination->initialize($config);
		$data['pagination']= $this->pagination->create_links();
		$data['count']=$config['total_rows'];
		$data['results']=$this->manage_office_m->get_office_list($page_from,ADMIN_LISTING,$_SESSION['order_by'],$_SESSION['order'],$_SESSION['search']);
		$this->load->view('admin/manage_office/index',$data);

	}


	function add_office()
	{

		$data['office_id']="0";
		$data['title']="Add Office";
		$data['countries']=$this->manage_country_m->get_countrys_list();
		$this->load->view('admin/manage_office/manage_office',$data);

	}

	function edit_office($office_id)
	{

		$data=$this->manage_office_m->get_office_info($office_id);
		$data['countries']=$this->manage_country_m->get_countrys_list();
		$data['title']="Edit Office";
		$this->load->view('admin/manage_office/manage_office',$data);

	}

	function delete_office($office_id)
	{

		$result=$this->manage_office_m->delete_office($office_id);
		if($result==1)
		{

			echo 'true';
		}
		elseif($result==2)
		{
			echo 'false';
		}
		else
		{
			echo 'exist';
		}


	}

	function manage_office_action()
	{
		$id=$this->input->post('office_id');


		if($this->input->post('office_name')!='')
		{
			$data = array(
			'office_id'    => $this->input->post('office_id'),
			'office_name' => $this->input->post('office_name'),
			'address' => $this->input->post('address'),
			'country_id' => $this->input->post('country_id'),
			'short_desc' => $this->input->post('short_desc'),
			'full_desc' => $this->input->post('full_desc'),
			'online_status' => $this->input->post('online_status'),
			'lat_long' => $this->input->post('lat_long'),
			'owner_name' => $this->input->post('owner_name'),
			'owner_email' => $this->input->post('owner_email'),
			'last_updated' => date("Y-m-d H:i:s")
			);
			$result=$this->manage_office_m->save_office($data);

			if($data['office_id']!=0)
			{
				$id=$data['office_id'];
			}
			else
			{
				if($result != false)
				{
					$id=$result;
				}
			}

			if(!is_dir('./office_files/'.$id))
			{
				mkdir('./office_files/'.$id,0777);
			}

			$config['upload_path'] = './office_files/'.$id;
			$config['allowed_types'] = 'gif|jpg|png|jpeg';
			$this->load->library('upload', $config);
			if(!empty($_FILES['image_path'])&&($_FILES['image_path']['error'] == 0))
			{
				$this->upload->do_upload('image_path');
				$file_details=$this->upload->data();
				$image_path=$file_details['file_name'];
				$this->_processimage2($image_path,$id);
			}
			else
			{
				$office=$this->manage_office_m->get_office_info($id);
				$image_path=$office['office_banner'];
			}

			$data = array(
			'office_id'    => $id,
			'office_banner' => $image_path
			);
			$result=$this->manage_office_m->save_office($data);


			$script = "top.edmSubmitComplete();";
			$this->_print_js_to_iframe($script);
		}
		else
		{
			$script = "top.edmSubmitError();";
			$this->_print_js_to_iframe($script);
		}
	}

	function export_result()
	{
		$offices=$this->manage_office_m->get_office_all($_SESSION['order_by'],$_SESSION['order'],$_SESSION['search']);

		$workbook = new Spreadsheet_Excel_Writer();
		$workbook->setTempDir('./tmp_excel/');
		$workbook->send('offices.xls');
		$workbook->setVersion(8);

		$worksheet =& $workbook->addWorksheet('Offices');
		$worksheet->setInputEncoding('utf-8');
		$worksheet->write(0, 0,'Office ID');
		$worksheet->write(0, 1,'Username');
		$worksheet->write(0, 2,'Learner Type');
		$worksheet->write(0, 3,'Learner ID');
		$worksheet->write(0, 4,'Email');
		$worksheet->write(0, 5,'Company');
		$worksheet->write(0, 6,'Country');
		$worksheet->write(0, 7,'Points');
		$worksheet->write(0, 8,'Credits');
		$worksheet->write(0, 9,'Votes');
		$worksheet->write(0, 10,'Last Login');
		$worksheet->write(0, 11,'Registered');
		$worksheet->write(0, 12,'Status');

		$cnt=1;
		foreach($offices as $office)
		{
			$worksheet->write($cnt, 0,$office['office_id']);
			$worksheet->write($cnt, 1,$office['username']);
			$worksheet->write($cnt, 2,$office['learner_type']);
			$worksheet->write($cnt, 3,$office['learner_id']);
			$worksheet->write($cnt, 4,$office['email']);
			$worksheet->write($cnt, 5,$office['company']);
			$worksheet->write($cnt, 6,$office['country']);
			$worksheet->write($cnt, 7,$office['total_points']);
			$worksheet->write($cnt, 8,$office['total_credits']);
			$worksheet->write($cnt, 9,$office['votes']);
			$worksheet->write($cnt, 10,$office['last_login_datetime']);
			$worksheet->write($cnt, 11,$office['registered_datetime']);
			$worksheet->write($cnt, 12,$office['account_status']);
			$cnt++;
		}
		$workbook->close();
	}

	function _print_js_to_iframe($script){
		$result = "<script type='text/javascript'>{$script}</script>";
		print($result);
	}

	function googlemap($lat_long)
	{
		$data['lat_long']=$lat_long;
		$this->load->view('admin/manage_office/googlemap',$data);
	}



	function add_images($window_id,$office_id)
	{
		$data=$this->manage_office_m->get_office_info($office_id);
		$data['window_id']=$window_id;
		$this->load->view('admin/manage_office/add_images',$data);
	}

	function add_images_action()
	{
		$id=$this->input->post('office_id');
		$window_id=$this->input->post('window_id');
		if(!is_dir('./office_files/'.$id))
		{
			mkdir('./office_files/'.$id);
			chmod('./office_files/'.$id,0777);
		}


		$config['upload_path'] = './office_files/'.$id;
		$config['allowed_types'] = 'gif|jpg|png|jpeg';
		$config['max_size']	= '40000';

		$this->load->library('upload', $config);
		for($i=1;$i<=10;$i++)
		{
			if(!empty($_FILES['image_'.$i])&&($_FILES['image_'.$i]['error'] == 0))
			{

				$this->upload->do_upload('image_'.$i);
				$image_details[$i]=$this->upload->data();
				$insert[$i]['image_'.$i]=$image_details[$i]['file_name'];
				$this->_processimage($insert[$i]['image_'.$i],$id);


				$this->manage_office_m->insert_office_item($id,$insert[$i]['image_'.$i]);
			}
		}

		for($i=1;$i<=10;$i++)
		{
			if(!empty($_FILES['image_'.$i])&&($_FILES['image_'.$i]['error'] == 0))
			{
				$this->_processimagethumb($insert[$i]['image_'.$i],$id);
				$this->_processimagethumb2($insert[$i]['image_'.$i],$id);
			}
		}


		$script = "top.edmSubmitComplete($window_id);";
		$this->_print_js_to_iframe($script);

	}

	function add_images_zip($window_id,$office_id)
	{
		$data=$this->manage_office_m->get_office_info($office_id);
		$data['window_id']=$window_id;
		$this->load->view('admin/manage_office/add_images_zip',$data);
	}

	function add_images_zip_action()
	{
		require_once('./common/pclzip.php');

		$this->load->library('upload', $config);

		$id=$this->input->post('office_id');
		$window_id=$this->input->post('window_id');
		if(!is_dir('./office_files/'.$id))
		{
			mkdir('./office_files/'.$id);
			chmod('./office_files/'.$id,0777);
		}

		$config['upload_path'] = './office_files/'.$id;
		$config['allowed_types'] = 'zip';
		$config['max_size']	= '40000';
		$this->upload->do_upload('image_zip');

		if(!empty($_FILES['image_zip'])&&($_FILES['image_zip']['error'] == 0))
		{
			$document_name = $_FILES['image_zip']['tmp_name'];
			$archive = new PclZip($document_name);
			$result = $archive->extract('./office_files/'.$id);
			$i=0;

			foreach($result as $image_details)
			{
				$new_filename[$i]=time().$image_details['stored_filename'];
				rename('./office_files/'.$id.'/'.$image_details['stored_filename'], './office_files/'.$id.'/'.$new_filename[$i]);
				$this->_processimage($new_filename[$i],$id);
				$this->manage_office_m->insert_office_item($id,$new_filename[$i]);
				$i++;
			}


			for($j=0;$j<sizeof($result);$j++)
			{
				$this->_processimagethumb($new_filename[$j],$id);
				$this->_processimagethumb2($new_filename[$j],$id);
			}
		}
		$script = "top.edmSubmitComplete($window_id);";
		$this->_print_js_to_iframe($script);
	}

	function manage_images($window_id,$office_id)
	{
		$data=$this->manage_office_m->get_office_info($office_id);
		$data['window_id']=$window_id;
		$data['images']=$this->manage_office_m->get_office_item($office_id);
		$this->load->view('admin/manage_office/manage_images',$data);
	}

	function manage_images_action()
	{
		$id=$this->input->post('office_id');
		$window_id=$this->input->post('window_id');
		$deletes=$this->input->post('delete_image');
		foreach($deletes as $delete)
		{
			$this->manage_office_m->delete_office_item($delete,$id);
		}

		$default_image=$this->input->post('default_image');
		$data['office_image_id']=$default_image;
		$data['default_image']='Yes';
		$this->manage_office_m->set_default_image($id,$data);

		$script = "top.edmSubmitComplete($window_id);";
		$this->_print_js_to_iframe($script);
	}

	function _processimage($picture_path,$id)
	{
		list($width, $height, $type, $attr) = getimagesize('./office_files/'.$id.'/'.$picture_path);

		if($width>600)
		{

			$config3['image_library'] = 'GD2';

			$config3['source_image'] = './office_files/'.$id.'/'.$picture_path;
			$config3['maintain_ratio'] = TRUE;
			$config3['new_image'] = './office_files/'.$id.'/'.$picture_path;
			$config3['height'] = $height/$width*600;
			$config3['width'] = 600;

			$this->image_lib->initialize($config3);
			$this->image_lib->resize();
		}

	}
	
	function _processimage2($picture_path,$id)
	{
		list($width, $height, $type, $attr) = getimagesize('./office_files/'.$id.'/'.$picture_path);
		
		$config2['image_library'] = 'GD2';
		$config2['source_image'] = './office_files/'.$id.'/'.$picture_path;
		$config2['height'] = 86;
		$config2['width'] = 212;
		$config2["maintain_ratio"] = false;
		$config2['x_axis'] = 0;
		$config2['y_axis'] = 0;
		$this->image_lib->initialize($config2);
		if ( ! $this->image_lib->crop())
		{
			echo $this->image_lib->display_errors();
		}
		

	}

	function _processimagethumb($picture_path,$id)
	{
		list($width, $height, $type, $attr) = getimagesize('./office_files/'.$id.'/'.$picture_path);
		$config1['image_library'] = 'GD2';
		//$config1['image_library'] = 'ImageMagick';
		//$config1['library_path'] = '/usr/X11R6/bin/';
		$config1['source_image'] = './office_files/'.$id.'/'.$picture_path;
		$config1['maintain_ratio'] = TRUE;
		$config1['new_image'] = './office_files/'.$id.'/thumb_'.$picture_path;
		if($height<=$width)
		{
			$config1['height'] = 48;
			$config1['width'] = (48/$height*$width);
		}
		else
		{
			$config1['height'] = (48/$width*$height);
			$config1['width'] = 48;
		}
		$this->image_lib->initialize($config1);
		$this->image_lib->resize();
		$config2['image_library'] = 'GD2';

		//$config2['image_library'] = 'ImageMagick';
		//$config2['library_path'] = '/usr/X11R6/bin/';
		$config2['source_image'] = './office_files/'.$id.'/thumb_'.$picture_path;
		$config2['height'] = 48;
		$config2['width'] = 48;
		$config2["maintain_ratio"] = false;
		$config2['x_axis'] = 0;
		$config2['y_axis'] = 0;
		$this->image_lib->initialize($config2);
		if ( ! $this->image_lib->crop())
		{
			echo $this->image_lib->display_errors();
		}

	}

	function _processimagethumb2($picture_path,$id)
	{
		list($width, $height, $type, $attr) = getimagesize('./office_files/'.$id.'/'.$picture_path);
		$config1['image_library'] = 'GD2';
		//$config1['image_library'] = 'ImageMagick';
		//$config1['library_path'] = '/usr/X11R6/bin/';
		$config1['source_image'] = './office_files/'.$id.'/'.$picture_path;
		$config1['maintain_ratio'] = TRUE;
		$config1['new_image'] = './office_files/'.$id.'/thumb2_'.$picture_path;
		if($height<=$width)
		{
			$config1['height'] = 215;
			$config1['width'] = (215/$height*$width);
		}
		else
		{
			$config1['height'] = (215/$width*$height);
			$config1['width'] = 215;
		}
		$this->image_lib->initialize($config1);
		$this->image_lib->resize();
		$config2['image_library'] = 'GD2';

		//$config2['image_library'] = 'ImageMagick';
		//$config2['library_path'] = '/usr/X11R6/bin/';
		$config2['source_image'] = './office_files/'.$id.'/thumb2_'.$picture_path;
		$config2['height'] = 215;
		$config2['width'] = 215;
		$config2["maintain_ratio"] = false;
		$config2['x_axis'] = 0;
		$config2['y_axis'] = 0;
		$this->image_lib->initialize($config2);
		if ( ! $this->image_lib->crop())
		{
			echo $this->image_lib->display_errors();
		}

	}



}
?>