<?php

class phpsession
{
    var $flash_key  = '__FLASH';

    /**
     * Constructor
     *
     * @param       string      The session name
     * @param       int         The session timeout (in seconds)
     */
    function phpsession($sessName = '__SESSION', $sessTimeout = 1800)
    {
        ini_set('session.gc_maxlifetime', $sessTimeout);
        session_name($sessName);
        session_start();
    }

    /**
     * Set a session variable.
     *
     * @param       mixed       The value to store
     */
    function set($key, $value)
    {
        $_SESSION[$key] = $value;
    }

    /**
     * Get session variable
     *
     * @param       string      The key to the value
     * @param       mixed       The value
     */
    function get($key)
    {
        return ((empty($_SESSION[$key])) ? false : $_SESSION[$key]);
    }

    /**
     * Destroy a session
     */
    function destroy()
    {
        $_SESSION = array();
        session_destroy();
    }


    /**
     * Save a flash session variable
     *  Flash Session is a session where once it's retrieved, it's deleted right away.
     *
     * @param       string      The value
     */
    function flashset($key, $value)
    {
        $_SESSION[$this->flash_key][$key] = $value;
    }


    /**
     * Get a flash session variable
     *
     * @param       string      The key
     * @param       mixed       The value
     */
    function flashget($key)
    {
        if(isset($_SESSION[$this->flash_key][$key]))
        {
            $value = $_SESSION[$this->flash_key][$key];
            unset($_SESSION[$this->flash_key][$key]);

            return $value;
        }
        else
        {
            return false;
        }
    }
}
?>