<?php


    /**
     * Print defined string inside a script tag
     *
     * @param   string  The string to be printed
     */
    function print_js($str)
    {
        print('<script>'. $str .'</script>');
    }


    /**
     * Config the Media Manager, and return the encrypted string
     *  then pass this string to the media_manager.php
     */
    function set_media_manager_setting($config_user)
    {
        // Set default config
        $config['use_folder_as_tree']   = true;     // Whether to use a folder as the tree structure
        $config['root_folder_id']       = null;     // null means the root folder (/)

        $config['use_ids_as_tree']      = false;    // Whether to use user specified media ids as trees
        $config['media_ids']            = array();  // The media ids in array

        // Single file tagging
        $config['show_tag']             = true;
        $config['callback_function']    = 'tag_file';

        // Mass file tagging
        $config['show_mtag']            = true;
        $config['mcallback_function']   = 'mtag_file';

        // Default thumbnail size
        $config['thumb_width']      = 72;
        $config['thumb_height']     = 72;

        // Max file res. size
        $config['file_width']   = 1240;
        $config['file_height']  = 768;

        // Folder management
        $config['show_add_folder']      = true;
        $config['show_add_subfolder']   = true;
        $config['show_del_folder']      = true;

        // Edit folder name
        $config['show_edit_folder']      = true;

        // File management
        $config['show_add_file']        = true;
        $config['show_edit_file']       = true;
        
        // Set user's config
        foreach($config_user as $k=>$v)
        {
            $config[$k] = $v;
        }

        // Save config
        $ci = &get_instance();

        if(!class_exists('CI_Encrypt'))
        {
            $ci->load->library('encrypt');
        }

        $config_enc = $ci->encrypt->encode(serialize($config));

        return $config_enc;
    }

    /**
     * Get the setting of the Media Manager from cookie
     *
     * @return  array   The media manager setting
     */
    function get_media_manager_setting()
    {
        if(empty($_COOKIE[MM_COOKIE]))
        {
            return false;
        }

        $ci = &get_instance();
        if(!class_exists('CI_Encrypt'))
        {
            $ci->load->library('encrypt');
        }
        $config = $ci->encrypt->decode($_COOKIE[MM_COOKIE]);
        $config = @unserialize($config);

        return $config;
    }

?>